//genesis
// axon.g - for the cable tutorial
// Author: Ed Vigmond 
// Date: 30/8/95
// Purpose: add an axon to the cable simulation and make the soma active


include hhchan1.g
include addcable.g


// function: create axon 
// create the axon with HH voltage dependent channels
function create_axon

	int i

	//make the first axon compartment
	make_excite_compartment /cell/axon[{0}] {axon_l} {axon_d} {ELEAK}
	link_compartment /cell/soma /cell/axon[{0}]

	//make the rest o the compartments
	for ( i=1; i < {NAxonSegs} ; i = i + 1 )
		make_excite_compartment /cell/axon[{i}] {axon_l} {axon_d} \
					{ELEAK}
		link_compartment /cell/axon[{i-1}] /cell/axon[{i}]
	end	

end


// function update_axon 
// called when the axon diameter is changed
// recalculate all values when the geometry is changed
function update_axon
	int i
	float harea	

	harea = { {axon_l}*{axon_d}*{PI} }
	for ( i=0; i < {NAxonSegs} ; i = i + 1 )
		update_hh /cell/axon[{i}] {harea}
		set_excite_compartment /cell/axon[{i}] {axon_l} {axon_d} {ELEAK}			
	end	
	
end	
	


