//genesis
/* compartment.g

	functions defined in this script
=============================================================================
	FUNCTION NAME		ARGUMENTS
=============================================================================
	makecompartment		(path,l,d,Erest)
	setcompartment		(path,l,d,Erest)
	set_method		(method)
=============================================================================
*/

include hhchan1.g

//=================================================
//                    COMPARTMENT
//=================================================
function makecompartment(path, l, d, Elev)
    str path
    float l, d
    float Elev
    float area = l*{PI}*d
    float xarea = {PI}*d*d/4
    /* global variables defined in cable.g
    float RM				// Kohm-cm^2
    float CM				// uF/cm^2
    float RA				// Kohm-cm
    */
    create compartment {path}
    // mV
    // Kohm
    // uF
    // Kohm
    setfield {path} Em {Elev} Rm {{RM}/area} Cm {{CM}*area}  \
        Ra {{RA}*l/xarea}
end


function make_excite_compartment(path, l, d, Elev)
    str path
    float l, d
    float Elev
    float area = l*{PI}*d
    float xarea = {PI}*d*d/4
    /* global variables defined in cable.g
    float RM_EX				// Kohm-cm^2
    float CM				// uF/cm^2
    float RA				// Kohm-cm
    */
    create compartment {path}
    // mV
    // Kohm
    // uF
    // Kohm
    setfield {path} Em {Elev} Rm {{RM_EX}/area} Cm {{CM}*area}  \
        Ra {{RA}*l/xarea}
    
    // add the channels
    add_hh_channels {path} {area}	
end


function setcompartment(path, l, d, Elev)
    str path
    float l, d
    float Elev
    float area = l*{PI}*d
    float xarea = {PI}*d*d/4
    // mV
    // Kohm
    // uF
    // Kohm
    setfield {path} Em {Elev} Rm {{RM}/area} Cm {{CM}*area}  \
        Ra {{RA}*l/xarea}
end


function set_excite_compartment(path, l, d, Elev)
    str path
    float l, d
    float Elev
    float area = l*{PI}*d
    float xarea = {PI}*d*d/4
    // mV
    // Kohm
    // uF
    // Kohm
    setfield {path} Em {Elev} Rm {{RM_EX}/area} Cm {{CM}*area}  \
        Ra {{RA}*l/xarea}
end


function set_method(method)// sets integration method for all compartments

    int method
    setmethod /cell/##[TYPE=compartment] {method}
    // save the current method in a global variable
    IntegMethod = {method}
end
