//genesis
// forms.g - for the cable tutorial

include xtools.g 
include helpforms.g 

// ==========================================
//   Functions used for popup parameter menus
// ==========================================

// ==========================================
//   Current Injection 
// ==========================================
// Popup Menu for timing, value and location of injection current
function make_inject_menu// Dialog boxes for injection current and timing

    create xform /output/inject_menu [695, 365, 330, 365]-nolabel
    pushe /output/inject_menu
    // in inputs.g
    create xtoggle injtoggle -title "" -script "inj_toggle injectpulse <v>"
    setfield injtoggle label0 "Current Injection OFF"
    setfield injtoggle label1 "Current Injection ON" state 1
    // initialize
    inj_toggle injectpulse 1
    // in inputs.g
    create xbutton DISMISS -hgeom 30 -script "xhide /output/inject_menu"
    create xdialog inject -title "Current (uA)" -value {injcurrent}
    create xdialog delay -title "Delay (msec)" -value {injdelay}
    create xdialog width -title "Width (msec)" -value {injwidth}
    create xlabel numbering -title "Compartment #0 = Soma"
    create xdialog comp_no -title "Inject Compartment:" -value 0
    //Axon injection 
    create xtoggle axinj -onlabel "Axon Injection On" \
		-offlabel "Axon Injection Off"  \
		-script "inj_toggle axinjectpulse <v>" \
		-state 0
    inj_toggle axinjectpulse 0
    create xdialog axinject -title "Current (uA)" -value {axinjcurrent}
    create xdialog axdelay -title "Delay (msec)"  -value {axinjdelay}
    create xdialog axwidth -title "Width (msec)"  -value {axinjwidth}
    create xdialog axcomp_no -title "Axon Inject Compartment:" -value 10
    pope
end

// ==========================================
//   Synaptic Input 
// ==========================================
// Popup Menu for location and parameters for synaptic input
function make_synapse_menu
    create xform /output/synapse_menu [333, 367, 320, 250]  -nolabel 
    pushe /output/synapse_menu
 
    create xlabel SYNFORM -label "Synaptic Input" 
    create xbutton DISMISS  -script    "xhide /output/synapse_menu"

	create xlabel SYNLABEL -label "Synapse" -wgeom 30%
    create xtoggle syntoggle -title "" -wgeom 35% -xgeom 0:SYNLABEL \
    			-ygeom 0:DISMISS
    setfield syntoggle label0 " 1 OFF"
    // initially  OFF
    setfield syntoggle label1 " 1 ON" state 0
    create xtoggle syntoggle2 -title "" -wgeom 35% -xgeom 0:syntoggle \
    			-ygeom 0:DISMISS
    setfield syntoggle2 label0 "2 OFF"
    // initially  OFF
    setfield syntoggle2 label1 "2 ON" state 0

    create xlabel DELAB -label "Period (ms)" -wgeom 30%
    create xdialog DELAY1 -label "" -xgeom 0:DELAB -ygeom 0:SYNLABEL \
    			-wgeom 35% -value {syndelay1}
    create xdialog DELAY2 -label "" -xgeom 0:DELAY1 -ygeom 0:SYNLABEL \
    			-wgeom 35% -value {syndelay2}
    
    create xlabel GSYNLAB -label "gsyn (mS)" -wgeom 30%
    create xdialog GSYN1 -label "" -xgeom 0:GSYNLAB -ygeom 0:DELAB \
    			-wgeom 35% -value {gsyn1}
    create xdialog GSYN2 -label "" -xgeom 0:GSYN1 -ygeom 0:DELAB \
    			-wgeom 35% -value {gsyn2}

    create xlabel TSYNLAB -label "Tsyn (ms)" -wgeom 30%
    create xdialog TSYN1 -label "" -xgeom 0:TSYNLAB -ygeom 0:GSYNLAB \
    			-wgeom 35% -value {tsyn1}
    create xdialog TSYN2 -label "" -xgeom 0:TSYN1 -ygeom 0:GSYNLAB \
    			-wgeom 35% -value {tsyn2}

    create xlabel ESYNLAB -label "Esyn (mV)" -wgeom 30%
    create xdialog ESYN1 -label "" -xgeom 0:ESYNLAB -ygeom 0:TSYNLAB \
    			-wgeom 35% -value {Vsyn1}
    create xdialog ESYN2 -label "" -xgeom 0:ESYN1 -ygeom 0:TSYNLAB \
    			-wgeom 35% -value {Vsyn2}

    create xlabel COMPLAB -label "Input to" -wgeom 30%
    create xdialog comp_no -label "" -xgeom 0:COMPLAB -ygeom 0:ESYNLAB \
    			-wgeom 35% -value 0
    create xdialog comp_no2 -label "" -xgeom 0:comp_no -ygeom 0:ESYNLAB \
    			-wgeom 35% -value 0

    create xtoggle traintog -title "" -script "traintoggle"
    	setfield traintog label1 "Single EPSP" label0 "EPSP Train"  \
    	    state 1
    pope
end

// ==========================================
//   Integration Method 
// ==========================================
// Menu for setting the integration method (uses set_method in compartment.g)
function make_method_menu
    create xform /output/method_menu [695,615,330,285] -title  \
        "Integration Method"
    pushe /output/method_menu
    create xbutton DISMISS -script "xhide /output/method_menu"
    create xbutton euler -title "Euler Method" -script "set_method -1"
    create xbutton exponential -title "Exponential Method" -script  \
        "set_method 0"
    create xbutton trapezoidal -title "Trapezoidal Method" -script  \
        "set_method 4"
    create xbutton gear -title "Gear Method" -script "set_method 1"
    create xbutton abash2 -title "Adams-Bashforth #2" -script  \
        "set_method 2"
    create xbutton abash3 -title "Adams-Bashforth #3" -script  \
        "set_method 3"
    create xbutton abash4 -title "Adams-Bashforth #4" -script  \
        "set_method 5"
    create xbutton abash5 -title "Adams-Bashforth #5" -script  \
        "set_method 6"
    create xbutton rungek -title "Runge Kutta Method" -script  \
        "set_method 7"
    pope
end

// ==========================================
//   Cell Parameters 
// ==========================================
// Menu for changing cell parameters
function make_param_menu
    str compartment
    str formpath = "/output/param_menu"
    create xform {formpath} [695,0,330,345] -nolabel
    disable {formpath}
    pushe {formpath}
    create xlabel cell_params -title "Cell Parameters"
    // create xbutton APPLY [5,25,157,20] -script "set_cell_params"
    //create xbutton DISMISS [167,25,157,20] -script "xhide "{formpath}
    create xbutton DISMISS -script "xhide "{formpath}
    create xlabel specific_rc -title "Specific Resistance/Capacitance"
    create xdialog RM -title "RM (Kohm*cm^2)" -value {RM} -script setRM
    create xdialog CM -title "CM (uF/cm^2)" -value {CM} -script setCM
    create xdialog RA -title "RA (Kohm*cm)" -value {RA} -script setRA
    create xlabel sizes -title "Compartmental Dimensions"
    create xdialog soma_l -title "soma radius (cm)" -value {soma_l}  \
        -script setsoma_l
    create xdialog dend_l -title "cable compt length (cm)" -value  \
        {dend_l} -script setdend_l
    create xdialog dend_d -title "cable compt diam (cm)" -value  \
        {dend_d} -script setdend_d
    create xdialog axon_l -title "axon compt length (cm)" -value  \
        {axon_l} -script setaxon_l
    create xdialog axon_d -title "axon compt diam (cm)" -value  \
        {axon_d} -script setaxon_d
    
    pope
end

// The following several specialized functions represent an offensively ugly
// kludge to deal with the way the "-script" field is parsed by Genesis

function setRM
  RM = {getfield /output/param_menu/RM value}
  echo "RM now set to "{RM}
end

function setCM
  CM = {getfield /output/param_menu/CM value}
  echo "CM now set to "{CM}
end

function setRA
  RA = {getfield /output/param_menu/RA value}
  echo "RA now set to "{RA}
end

function setsoma_l
  soma_l = {getfield /output/param_menu/soma_l value}
  echo "soma radius now set to "{soma_l}
end

function setdend_l
  dend_l = {getfield /output/param_menu/dend_l value}
  echo "dend_l now set to "{dend_l}
end

function setdend_d
  dend_d = {getfield /output/param_menu/dend_d value}
  echo "dend_d now set to "{dend_d}
end

function setaxon_l
  int i
  axon_l = {getfield /output/param_menu/axon_l value}
  update_axon	
  echo "axon_l now set to "{axon_l}
end

function setaxon_d
  int i
  axon_d = {getfield /output/param_menu/axon_d value}
  update_axon	
  echo "axon_d now set to "{axon_d}
end

function set_cell_params// uses global RM, CM, RA, len, diam

  int i
  pushe /cell
  set_excite_compartment soma {soma_l} {soma_l} {ELEAK}
  echo
  echo "Soma Rm (membrane resistance, Kohms) = "{getfield soma Rm}
  echo "Soma Cm (membrane capacitance, uF)   = "{getfield soma Cm}
  echo "Soma Ra (axial resistance, Kohms)    = "{getfield soma Ra}
  echo "Axon compartment length (cm)         = "{axon_l}
  if ({NCableSects} != 0)
     for (i = 0; i < {NCableSects}; i = i + 1)
       setcompartment /cell/cable[{i}] {dend_l} {dend_d} {EREST_ACT}
     end
  echo  \
      "Cable compartment Rm (membrane resistance, Kohms) = "{getfield cable[0] Rm}
  echo  \
      "Cable compartment Cm (membrane capacitance, uF)   = "{getfield cable[0] Cm}
  echo  \
      "Cable compartment Ra (axial resistance, Kohms)    = "{getfield cable[0] Ra}
  echo "Total cable length = "{{NCableSects}*{dend_l}}  \
      " cm. ("{NCableSects}" sections)"
  end  // if

  pope
  //  if we set the xcell fatfield to calc_dia, we need to remake the widget
  //  however, propagation_toggle is defined later in this script
  //  set /output/control/propagation state 0
  //  propagation_toggle
end

// Popup menu for adding/removing cable Vm plots
function make_plot_menu
    create xform /output/plot_menu [215,50,220,120] -title  \
        "Add/Remove Plots"
    pushe /output/plot_menu
    create xbutton DISMISS -script "xhide /output/plot_menu"
    create xbutton remove -title "Remove Cable Plots" -script  \
        "remove_cable_plots"
    create xdialog add -title "Plot Sect #" -value 0 -script  \
        "add_cable_plot"
    pope
end

//functions used to add and remove cable plots
function add_cable_plot
    // cable section to plot (numbered from 1)
    int section
    section = ({getfield /output/plot_menu/add value})

    if ((section) > ({NCableSects}))
        echo "There are only "{NCableSects}" cable sections!"
	return
    end
    if ((section) < 1)
	echo "In our notation, the first cable section is #1."
	return
    end

    pushe /output/somagraphs
    
    if (({getmsg somaVm_grf -find /cell/cable[{section - 1}] PLOT }) != (-1))
	echo "Plot already exists!"
	pope
	return
    end
    
    addmsg /cell/cable[{section - 1}] somaVm_grf PLOT Vm  \
    *"cable "{section} *red
    pope
    echo "Vm plots added for cable section #"{section}
    // needed to initialize the table
    reset
end


function remove_cable_plots
    // greatly simplified by Ed Vigmond 
    int i, n, nmsg
    
    pushe /output/somagraphs
    for (i = 0; i < {NCableSects}; i = i + 1)
	nmsg = {getmsg somaVm_grf -find /cell/cable[{i}] PLOT }
	if( {nmsg} != (-1) )    // then plot messages exist for cable[{i}]
	    deletemsg somaVm_grf {nmsg}         
	end      // if
    end  // for i
    pope    
    setfield /output/plot_menu/add value 0
    echo "Plotting of Vm for cable sections removed."
end

// functions used in MAIN CONTROL PANEL

// change_stepsize  -  sets clock 0

function change_stepsize
    dt = {getfield /output/control/stepsize value}
    setclock 0 {dt}
    echo dt = {dt}
    setfield /##[TYPE=spike] output_amp {1.0/{getclock 0}}
end

// toggle the display of channel conductance
function conductance_toggle
  if ({getfield /output/control/conductance state} == 1)
      xshowontop /output/condgraphs
  else
      xhide /output/condgraphs
  end
end

// toggle the display of Vm along the cable
function propagation_toggle
  if ({getfield /output/control/propagation state} == 1)
      make_draw {{NCableSects} + 1}
      xshowontop /viewform
  else
      if ({exists /viewform/draw})
          delete_draw
      end
      xhide /viewform
  end
end

//toggle display of axon and hillock plots
function axon_plot_toggle
  if ({getfield /output/control/axon_plot state} == 1)
      xshow /output/axon_plot
  else
      xhide /output/axon_plot
  end
end
	
// =======================================================
//  The two main functions, loadgraphs and loadcontrol
//  set up the forms used for graphs and control buttons
// =======================================================
function loadgraphs
     // activate XODUS
     
     // While forms are being loaded, put up some credits
     echo " "
     echo "*************************************************"
     echo "*                                               *"
     echo "*                Propagation                    *"
     echo "*                                               *"
     echo "*     A simulation of a complete neuron         *"
     echo "*                                               *"
     echo "*                (version 1.1)                  *"
     echo "*                                               *"
     echo "*                  E. Vigmond                   *"
     echo "*                                               *"
     echo "*            UNIVERSITY OF TORONTO              *"
     echo "*                                               *"
     echo "*************************************************"
     echo " "
    // give it color
    xcolorscale hot

    // make graphs for soma Vm
    create xform /output/somagraphs [215,0,480,300] -nolabel
    pushe /output/somagraphs
    create xgraph somaVm_grf [0,0,480,300] -title  \
        "Soma membrane potential Vm (mV)"
    setfield somaVm_grf xmin 0 xmax {tmax} ymin {EREST-30} ymax {20} \
	 XUnits "msec"  YUnits "Vm (mV)"
    useclock somaVm_grf 1
    makegraphscale /output/somagraphs/somaVm_grf

    pope
    xshow /output/somagraphs

    // make a graph for conductances
    create xform /output/condgraphs [215,320,480,300] -nolabel
    pushe /output/condgraphs
    create xgraph channel_Gk [0,0,480,300] -title  \
        "Channel Conductance (mS)"
    setfield channel_Gk xmin 0 xmax {tmax} ymin 0 ymax {{gsyn1}*2}
    setfield channel_Gk XUnits "msec" YUnits "Gk (mS)"
    useclock channel_Gk 1
    makegraphscale /output/condgraphs/channel_Gk
    pope
    // work around bug that sets it to 415
    setfield /output/condgraphs hgeom 300

    //make a graph for axon
    create xform /output/axon_plot [415,520,480,300] -nolabel
    pushe /output/axon_plot
    create xgraph voltage  -title  \
        "Axon Voltage (mV)"
    setfield voltage xmin 0 xmax {tmax}  ymin {EREST-30} ymax 40
    setfield voltage XUnits "msec" YUnits " Vm (mV)"
    useclock voltage 1
    makegraphscale /output/axon_plot/voltage
    pope
    
end// loadgraphs


    // =================================================
    //                MAIN CONTROL PANEL
    // =================================================
function loadcontrol
    create xform /output/control [0,0,215,455] -nolabel
    pushe /output/control
    create xbutton resetdefaults -title "Reset Defaults" -script  \
        "ResetDefaults"
    create xbutton HELP -script "xshowontop /output/helpmenu"
    create xbutton stop -title STOP -script stop
    create xbutton quit -title QUIT -script "quitbutton <widget>"
    makeconfirm quit "Quit CABLE?" "quit" "cancelquit <widget>" 10 10

    create xtoggle overlay -title "" -script "overlaytoggle <widget>"
    setfield overlay label0 "Overlay OFF" label1 "Overlay ON" state 0
    overlaytoggle /output/control/overlay
    // be sure that it is in state 0 after Reset Defaults
    create xbutton reset -title RESET -script resetbut
    create xdialog step -title "STEP (msec)" -script  \
        "stepbutton <widget>" -value {tmax}
    create xdialog stepsize -title "dt" -script "change_stepsize"  \
        -value {dt}
    create xbutton params -title "Change Cell Parameters" -script  \
        "xshow /output/param_menu"
    create xbutton inject -title "Change Current Injection" -script  \
        "xshow /output/inject_menu"
    create xbutton synapse -title "Change Synaptic Input" -script  \
        "xshow /output/synapse_menu"
    create xbutton method -title "Change Integration Method" -script  \
        "xshow /output/method_menu"
    // defined in addcable.g
    create xdialog nsections -title "No. of Cable Sects." -value {1} \
        -script "add_cable"
    create xbutton addplot -title "Add/Remove Plots" -script  \
        "xshow /output/plot_menu"

    create xtoggle conductance -title "" -script conductance_toggle
        setfield conductance label0 "Conductance Plot Hidden"
	setfield conductance label1 "Conductance Plot Visible" state 0
	// be sure it is properly initialized
	conductance_toggle

//    create xtoggle propagation -title "" -script propagation_toggle
//      setfield propagation label0 "Vm Propagation Hidden"
//	setfield propagation label1 "Vm Propagation Visible" state 0
//	// be sure it is properly initialized
//	propagation_toggle

    create xtoggle axon_plot -script axon_plot_toggle -onlabel "Hide Axon Plot" \
	-offlabel "Display Axon Plot"
 
    pope
    make_param_menu
    make_inject_menu
    make_synapse_menu
    make_method_menu
    make_plot_menu
    xshow /output/control
end// loadcontrol



function resetbut
	set_inputs
	set_injection
	set_cell_params
	setfield /input/synpulse1 trig_time 0
	setfield /input/synpulse2 trig_time 0
end
